package de.intevation.flys.importer;

import de.intevation.flys.model.WstColumnValue;
import de.intevation.flys.model.DischargeTableValue;


public class IdValueKey {

    protected int    id;
    protected double a;
    protected double b;


    public IdValueKey(WstColumnValue value) {
        this.id = value.getWstColumn().getId();
        this.a  = value.getPosition().doubleValue();
        this.b  = value.getW().doubleValue();
    }

    public IdValueKey(DischargeTableValue value) {
        this.id = value.getDischargeTable().getId();
        this.a  = value.getQ().doubleValue();
        this.b  = value.getW().doubleValue();
    }


    public IdValueKey(int id, double a, double b) {
        this.id = id;
        this.a  = a;
        this.b  = b;
    }

    private static final int hashDouble(double d) {
        long v = Double.doubleToLongBits(d);
        return (int)(v^(v>>>32));
    }

    public int hashCode() {
        int a = id;
        int b = hashDouble(a);
        int c = hashDouble(b);

        return (a | (b << 10) | (c << 20));
    }


    public boolean equals(Object obj) {
        if (!(obj instanceof IdValueKey)) {
            return false;
        }

        IdValueKey other = (IdValueKey) obj;

        return id == other.id
            && a  == other.a
            && b  == other.b;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
